#include <GL/glut.h>    // Header File For The GLUT Library 
#include <GL/gl.h>	// Header File For The OpenGL32 Library
#include <GL/glu.h>	// Header File For The GLu32 Library
#include <iostream>
#include <cstdlib>
#include <vector>
#include "Explosions.h"
#include "Input.h"
#include "Globals.h"
#include "Interface.h"
#include <cmath>
#include <stdlib.h>
#include <time.h>
#include "Basics.h"
#include "GLFunctions.h"
using namespace std;

Explosion::Explosion()
{
	cout<<"Cant spawn an explosion with no parameters!\n";
}

Explosion::Explosion(float cX,float cY,float cZ,int numParts, float r,float g,float b, float rad)
{
	exploded = 0;
	centreX = cX;
	centreY = cY;
	centreZ = cZ;
	radius = rad;
	numParticles=numParts;		
	particles = makepointList(cX,cY,cZ);
	for (int i=0; i<numParts-1;i++)
	{
		addtopointList(particles,cX,cY,cZ);
	}
	srand ( time(NULL) );
	float rX,rY,rZ,isNeg;
	isNeg = rand()%2;
	isNeg-=0.5;
	rX = rand()%10/100.0;
	rX*=isNeg;
	isNeg = rand()%2;
	isNeg-=0.5;
	rY = rand()%10/100.0;
	rY*=isNeg;
	isNeg = rand()%2;
	isNeg-=0.5;
	rZ = rand()%10/100.0;
	rZ*=isNeg;
	directions = makepointList(rX,rY,rZ);
	for (int i=0; i<numParts-1;i++)
	{
		isNeg = rand()%2;
		isNeg-=0.5;
		rX = rand()%10/100.0;
		rX*=isNeg;
		isNeg = rand()%2;
		isNeg-=0.5;
		rY = rand()%10/100.0;
		rY*=isNeg;
		isNeg = rand()%2;
		isNeg-=0.5;
		rZ = rand()%10/100.0;
		rZ*=isNeg;
		

		cout<<"Particle "<<i<<"'s Direction is "<<rX<<","<<rY<<","<<rZ<<endl;
		addtopointList(directions,rX,rY,rZ);
	}
	color[0]= r;
	color[1]= g;
	color[2]= b;
	isUpdating = 0;
}
void Explosion::updateParticles()
{
	float boundX=0, boundY=0, boundZ=0;
	float testX,testY,testZ;
	if (isUpdating)
	{
		pointListNode* currentParticle;
		currentParticle = particles;
		pointListNode* currentDirection;
		currentDirection = directions;
			while (currentParticle !=NULL)
			{
				currentParticle->x+=currentDirection->x;
				currentParticle->y+=currentDirection->y;
				currentParticle->z+=currentDirection->z;
				//cout<<"Checking particle\n";
				testX = currentParticle->x+currentDirection->x;
				testY = currentParticle->x+currentDirection->x;
				testZ = currentParticle->x+currentDirection->x;
				boundX = abs(centreX)+abs(radius);
				boundY = abs(centreY)+abs(radius);
				boundZ = abs(centreZ)+abs(radius);
				//cout<<"Boundaries are "<<boundX<<","<<boundY<<","<<boundZ<<endl;
				//printpointList(particles);
				if (testX >=boundX || testX <= -boundX || testY >=boundY || testY <= -boundY ||  testZ >=boundZ || testZ <= -boundZ)
				{
					//cout<<"particle outside bounds\n";
					isUpdating=0;			
				}
				
				currentParticle = currentParticle->next;
				currentDirection = currentDirection->next;
			}
		//cout<<"Particles updating\n";
	}
		//cout<<"Isnt updating\n";
}
void Explosion::draw()
{
	float BOMB[] = { color[0],color[1], color[2], 1.0f };
	glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, BOMB);
	if (!exploded)
	{
		glPushMatrix();
			//glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, BOMB);
			glTranslatef(centreX,centreY,centreZ);
			bomb.DrawObject();
		glPopMatrix();
	}

	pointListNode* current;
	current = particles;
	//cout<<"Before loop"<<endl;
	//printpointList(coords);
	glBegin(GL_POINTS);
		while (current !=NULL)
		{
			glPushMatrix();
				glTranslatef(current->x,current->y,current->z);
				glutSolidSphere(0.2,2,2);
			glPopMatrix();
			current = current->next;
		}

	glEnd();
	//cout<<"Particles updating\n";
}
void Explosion::wipe()
{
	
	destroypointList(directions);
	destroypointList(particles);
	cout<<"Destroyed Explosion\n";
}
Explosion::~Explosion()
{

}

vector<Explosion> Explosions;

void makeNewExplosion(float cxX,float cyY,float czZ,int numPartis, float rd,float gn,float bu, float radi)
{
		srand(time(NULL));
		Explosion newExplosion(cxX,cyY,czZ,rand()%50, rd,gn,bu,radi);
		Explosions.push_back(newExplosion);
		//newExplosion.wipe();

}
void drawExplosions()
{
	for (unsigned int i=0;i<Explosions.size();i++)
	{
			float objColor[4];
			objColor[0] = Explosions[i].color[0];
			objColor[1] = Explosions[i].color[1];
			objColor[2] = Explosions[i].color[2];
			objColor[3] = 0.8;
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, objColor);
			Explosions[i].draw();
	
		
	}

}

void updateExplosions()
{
	for (unsigned int i=0;i<Explosions.size();i++)
	{
			Explosions[i].updateParticles();
	
	}

}

void explosionCleanUp()
{
	for (unsigned int i=0;i<Explosions.size();i++)
	{
			Explosions[i].wipe();
	
	}

}

void Explode()
{
	
	for (unsigned int i=0;i<Explosions.size();i++)
	{
			
			if (!Explosions[i].exploded)
			{
				glClearColor(1.0f, 1.0f, 1.0f, 0.0f);
				glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);	// Clear The Screen And The Depth Buffer
				glClearColor(0.2f, 0.2f, 0.3f, 0.0f);
				glutSwapBuffers();
				DrawGLScene();
				Explosions[i].exploded = 1;
				Explosions[i].isUpdating = 1;
			}
	
	}

}




















