#include "Globals.h"
#include <iostream>
#include <GL/glut.h>    // Header File For The GLUT Library 
#include <cmath>
#include "Basics.h"
#include "Interface.h"
#include "Input.h"
#include "uObject.h"
#include "Explosions.h"
using namespace std;
float mX,mY,mZ;
float XRot,YRot,ZRot;
int rotating;
int mouseDownX,mouseDownY;
float camX,camY,camZ;
float camXdown,camYdown,camZdown,handXdown,handYdown,handZdown;
float AngleOfRotation = -90.0;
int posrot;
int prevX;
int wiped = 0;
pointListNode* movementSlate;
int drawing=0;
int donefirstpoint = 0;
float temp=0.0;
extern int changingHeight;
extern int movingPlate;
extern int mouseOverSave;
extern int holdingBomb;

void updateMousePos(int xx, int yy)
{
	mX=(512 - xx)*-0.035;
	mZ=((768/2)-yy)*-0.035;
	//mY = 0;
	float radiansVersion;
	float newX,newZ;
	radiansVersion = (PI/180)*-AngleOfRotation;
	newX = mZ*cos(radiansVersion);
	newX = newX+(mX*sin(radiansVersion));
	newZ = mZ*-sin(radiansVersion);
	newZ = newZ+(mX*cos(radiansVersion));
	mX=newX;
	mZ=-newZ;
	//cout<<"mouse is at "<<mX<<","<<mY<<","<<mZ<<endl;
	//mY = 0.4;
}

void PassiveMotion ( int xx, int yy )
{
	updateMousePos(xx,yy);
	if (checkMouseOver(mX,mZ) == TRUE)
	{
		//cout<<"Mouse over something\n";
		penUP = 0;
	}
}

void ClickedMotion(int xx, int yy)
{
	checkMouseOver(mX,mZ);
	if (rotating)
	{ 
		
			//cout<<"cam initial X,Y,Z is "<<camXdown<<","<<camYdown<<","<<camZdown<<endl;
			
			float radiansVersion;
			float newX,newZ;
			float difference;
			//cout<<"Difference is "<<xx-prevX<<endl;
			difference = 0.1*(xx-prevX);
			prevX = xx;			
			//cout<<"Angle of Rotation is "<<AngleOfRotation<<endl;
			AngleOfRotation += difference;
			radiansVersion = (PI/180)*AngleOfRotation;
			newX = 20.0*cos(radiansVersion);
			newX = newX+(sin(radiansVersion));
			newZ = 20.0*-sin(radiansVersion);
			newZ = newZ+(cos(radiansVersion));
			XRot = newX;
			ZRot = newZ;
			camX = XRot;
			camZ = ZRot;
			//camY=20.0;
			int ydiff;
			ydiff = mouseDownY-yy;
			if ((camY+ydiff*0.0005)>=0)
				camY+=ydiff*0.0005;
	}
	if (drawing && !penUP)
	{
		updateMousePos(xx,yy);
		if (donefirstpoint=0)
			{
				storeMovement(mX,mY,mZ);
				donefirstpoint=1;
			}
			static int count;
		
			if (count == 2)
			{
					storeMovement(mX,mY,mZ);
					count = 0;
			}
			else
			count++;
	}
	if (changingHeight)
	{
		int ydiff;
		ydiff = mouseDownY-yy;
		if ((mY+ydiff*0.01)<=4)
		{
			if ((mY+ydiff*0.01)>=0)
			{
				mY+=ydiff*0.005;
			}
	
		}
		//mouseDownY = yy;
	}
	if (movingPlate)
	{
		//float offX=0.0,offY=0.0,offZ=0.0;
		//offX =  handXdown-mX;
		//offY =  handYdown-mY;
		//offZ =  handZdown-mZ;
		//cout<<"ORIGINAL MOUSE XYZ "<<handXdown<<","<<handYdown<<","<<handZdown<<endl;
		//cout<<"OFFSETS FOR MOVING ARE "<<offX<<","<<offY<<","<<offZ<<endl;
		//moveAll(-offX,offY,-offZ);
		//handXdown = mX;
		//handYdown = mY;
		//handZdown = mZ;
		updateMousePos(xx,yy);
		

	}
	if (holdingBomb)
	{
		updateMousePos(xx,yy);
	}
}

void ButtonClick(int button, int state,int xx, int yy)
{
	
	if ((button == GLUT_MIDDLE_BUTTON)&&(state==GLUT_DOWN))
	{
		//AngleOfRotation = 0.0;
		prevX = xx;
		mouseDownX = xx;
		mouseDownY = yy;
		camXdown = camX;
		camYdown = camY;
		camZdown = camZ;
		handXdown = mX;
		handZdown = -mZ;
		handYdown = mY;
		rotating = TRUE;
		//cout<<"Mouse down cam is at "<<camXdown<<","<<camYdown<<","<<camZdown<<endl;
	}
	if ((button == GLUT_MIDDLE_BUTTON)&&(state==GLUT_UP))
	{
		//cout<<"Cam X,Z "<<camX<<","<<camZ<<endl;
	
		rotating = FALSE;
	}
	if ((button == GLUT_LEFT_BUTTON)&&(state==GLUT_DOWN))
	{
			checkClick(mX,mZ,1);
			if (!penUP)
				drawing = TRUE;
	}
	if ((button == GLUT_LEFT_BUTTON)&&(state==GLUT_UP))
	{
		makeShape(movementSlate);
		//printpointList(movementSlate);
		wipeSlate();
		drawing = FALSE;
	}	
	if ((button == GLUT_RIGHT_BUTTON)&&(state==GLUT_DOWN))
	{
			checkClick(mX,mZ,2);
			if (movingPlate)
			{
				cout<<"You just picked up a plate\n";
			}
	}
	if ((button == GLUT_RIGHT_BUTTON)&&(state==GLUT_UP))
	{
			if (movingPlate)
			{
				if (mouseOverSave)
				{
					cout<<"moved all back by "<<mX<<","<<mZ<<endl;
					//moveAll(-mX,0,-mZ);
					dropPlate(0.0,0.0);
					writeShot(1);
				}
				else
				{
					dropPlate(mX,mZ);
				}
				movingPlate = FALSE;
			}
			changingHeight = FALSE;
			if (holdingBomb)
			{
				makeNewExplosion(mX,mY,mZ,20,pen.red,pen.green,pen.blue,5.0);
				holdingBomb=FALSE;
			}
	}
}


void storeMovement(float xx ,float yy,float zz)
{

	if (wiped==0)
	{
		movementSlate = makepointList(xx,yy,zz);
		wiped=1;
	}
	else
	{
		addtopointList(movementSlate,xx,yy,zz);
	}
	//cout<<"Stored movement at "<<xx<<","<<yy<<","<<zz<<endl;
}

void wipeSlate()
{
	if (wiped != 0)
	{
		//cout<<"---------------wipe slate called"<<endl;
		destroypointList(movementSlate);
		wiped = 0;
		movementSlate = NULL;
	}
}

void drawMovementPath()
{
	if (movementSlate !=NULL)
	{
		extern mypen pen;
		//cout<<"Drawing line\n";
		pointListNode* current;
		current = movementSlate;
		glColor3f(pen.red,pen.green,pen.blue);
		glLineWidth(4);
		glBegin(GL_LINE_STRIP);
			while (current !=NULL)
			{
				//cout<<"In loop"<<endl;
				glVertex3f(current->x,current->y, current->z);
				//cout<<"Drawn vertex"<<endl;
				current = current->next;
			}

		glEnd();
	}
}
