#include <GL/glut.h>    // Header File For The GLUT Library 
#include <GL/gl.h>	// Header File For The OpenGL32 Library
#include <GL/glu.h>	// Header File For The GLu32 Library
#include <IL/il.h>
#include <IL/ilu.h>
#include <IL/ilut.h>
#include "Globals.h"
#include "Interface.h"
#include "GLFunctions.h"
#include "Explosions.h"
//#include <libtiff/tiffio.h>
#include <stdlib.h>
#include <string>
#include <sstream>
#include <stdio.h>
#include <time.h>
hotArea::hotArea()
{// default constructor
cout<<"WARNING: Dont use a default constructor for this class!"<<endl;
x = 0;z=0;width=0;height=0;ID=99999;

}

hotArea::hotArea(float xx, float zz, float nwidth,float nheight)
{
static int nID=0;
x = xx;
z = zz;
width = nwidth;
height = nheight;
ID = nID;
nID++;
cout<<"made hot area numbered "<<ID<<endl;
}

hotArea::hotArea(float xx, float zz, float nwidth,float nheight,int nuID)
{
x = xx;
z = zz;
width = nwidth;
height = nheight;
ID = nuID;
cout<<"made special hot area numbered "<<ID<<endl;
}


int hotArea::Check(float cX,float cZ)
{
	
	//cout<<"Checking Hot Area "<<ID<<endl;
	if ((cX < x+width) && (cX > x) && (cZ < z+height) && (cZ > z))
	{
		glDisable(GL_LIGHTING);
		glPushMatrix();
			glColor3f(1.0,1.0,1.0);
			glTranslatef(x,0.5,z);
			glBegin(GL_LINE_LOOP);
			glLineWidth(6);
				glVertex3f(0.0,0.0,0.0);
				glVertex3f(width,0.0,0.0);
				glVertex3f(width,0.0,height);
				glVertex3f(0.0,0.0,height);
				//glVertex3f(0.0,0.0,0.0);
			glLineWidth(1);
			glEnd();
		glPopMatrix();
		glutSwapBuffers();
		glEnable(GL_LIGHTING);
		return 1;
	}
	
	else
		return 0;
	
}

void hotArea::Move(float offX,float offY,float offZ)
{
	x+= offX;
	//x+= offX;
	z+= offZ;
}



OBJFile hand;
OBJFile holdinghand;
OBJFile paintBucket;
OBJFile paintLevel;
OBJFile waterPot;
OBJFile waterBlob;
OBJFile modelPlate;
OBJFile heightPole;
OBJFile heightBlock;
OBJFile saveFolder;
OBJFile bomb;
OBJFile plunger;
OBJFile land;
OBJFile coins;
OBJFile treetrunk;
OBJFile treeleaves;
extern float camX,camY,camZ;

hotArea RedPot(-12.5,-9.5,3,3);
hotArea GreenPot(-12.5,-7,3,3);
hotArea BluePot(-12.5,-3.5,3,3);
hotArea WhitePot(-12.5,-0.5,3,3);
hotArea BlackPot(-12.5,2.5,3,3);
hotArea WaterPot(-12.5,5.5,3,3);
hotArea heightPoleArea(3,-1,3,3);
hotArea PlateStack(-2,0,2,2,-99);
hotArea BigPlate(0,0,2,2,-88);
hotArea SaveFolder(-12.5,9.0,4,4);
hotArea bombPile(12.5,4.0,3,3);
hotArea plungerArea(12.5,1.0,3,3);

float RED[] = { 1.0f, 0.0f, 0.0f, 0.8f };
float GOLD[] = { 1.0f, 1.0f, 0.0f, 1.0f };
float VRED[] = { 1.0f, 0.2f, 0.2f, 1.0f };
float BOMB[] = { 0.2f, 0.2f, 0.2f, 1.0f };
float GREEN[] = { 0.0f, 1.0f, 0.0f, 0.8f };
float BLUE[] = { 0.0f, 0.0f, 1.0f, 0.8f };
float WHITE[] = { 0.9f, 0.9f, 0.9f, 0.8f };
float BLACK[] = { 0.0f, 0.0f, 0.0f, 0.8f };
float BLACK2[] = { 0.0f, 0.0f, 0.0f, 1.0f };
float GLASS[] = { 0.8f, 0.8f, 0.9f, 0.4f };
float WATER[] = { 0.8f, 0.8f, 0.8f, 0.8f };
float WATER2[] = { 0.5f, 0.7f, 0.95f, 0.7f };
float WATER3[] = { 0.3f, 0.4f, 0.5f, 0.9f };
float PLATE[] = { 0.9f, 0.5f, 0.4f, 1.0f };
float DIRT[] = { 0.9f, 0.9f, 0.4f, 1.0f };
float LEAF[] = { 0.6f, 0.8f, 0.3f, 1.0f };
float TRUNK[] = { 0.4f, 0.2f, 0.2f, 1.0f };
float handcolor[] = { 0.85f, 0.75f, 0.65f, 1.0f };
float handGLOW[] = { 0.95f, 0.85f, 0.75f, 1.0f };
float bucket[] = { 0.5f, 0.5f, 0.5f, 1.0f };
int penUP=1,handGLOWING=0,changingHeight=0,movingPlate=0,mouseOverSave=0,holdingBomb=0;
//float penrgb[3];
mypen pen;
int savecount=0;
void initInterface()
{
	pen.red = 0.5;	
	pen.green = 0.5;
	pen.blue = 0.5;
	camX = 0.0;
	camY = 20.0;
	camZ = 20.0;
	mY = 0.4;
	land.LoadInObjectFile("land.obj");
	treetrunk.LoadInObjectFile("trunks.obj");
	treeleaves.LoadInObjectFile("foliage.obj");
	coins.LoadInObjectFile("coins.obj");
	hand.LoadInObjectFile("hand-NORM2.obj");
	bomb.LoadInObjectFile("bomb.obj");
	plunger.LoadInObjectFile("plunger.obj");
	saveFolder.LoadInObjectFile("chest.obj");
	holdinghand.LoadInObjectFile("hand-HOLD.obj");
	paintBucket.LoadInObjectFile("paintBucket.obj");
	paintLevel.LoadInObjectFile("paintLevel.obj");
	waterPot.LoadInObjectFile("waterPot.obj");
	waterBlob.LoadInObjectFile("waterBlob.obj");
	modelPlate.LoadInObjectFile("modelplate.obj");
	heightPole.LoadInObjectFile("heightPole.obj");
	heightBlock.LoadInObjectFile("heightBlock.obj");
	ilInit();
	iluInit();
	ilutInit();
}

void drawInterface()
{
	//glEnable(GL_LIGHTING);
	extern float mX,mY,mZ;
	extern float AngleOfRotation;
	glPushMatrix();
		glTranslatef(mX,mY+0.2,mZ);
		glRotatef(AngleOfRotation,0.0,1.0,0.0);
		glColor3f(0.95,0.85,0.75);
		
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, handcolor);
		hand.DrawObject();
		//glTranslatef(-1.4,0.1,0.3);
		if (!penUP)
		{	glDisable(GL_LIGHTING);
			glColor3f(pen.red,pen.green,pen.blue);
			glutSolidSphere(0.2,3,3);
			glEnable(GL_LIGHTING);
		}
	glPopMatrix();
	//glEnable(GL_LIGHTING);
	glPushMatrix();
		glColor3f(0.9,0.9,1.0);
		//float grid[] = { 0.65f, 0.95f, 0.05f, 1.0f };
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, DIRT);
		land.DrawObject();
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, TRUNK);
		treetrunk.DrawObject();
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, LEAF);
		treeleaves.DrawObject();
		//glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, grid);
		//glBegin(GL_QUADS);
		//	glVertex3f(5.0,0.4,5.0);
		//	glVertex3f(-5.0,0.4,5.0);
		//	glVertex3f(-5.0,0.4,-5.0);
		//	glVertex3f(5.0,0.4,-5.0);
		//glEnd();
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, BLACK2);
		glBegin(GL_QUADS);
			glVertex3f(100.0,-9,100.0);
			glVertex3f(-100.0,-9,100.0);
			glVertex3f(-100.0,-9,-100.0);
			glVertex3f(100.0,-9,-100.0);
		glEnd();
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, WATER3);
		glBegin(GL_QUADS);
			glVertex3f(100.0,-8.5,100.0);
			glVertex3f(-100.0,-8.5,100.0);
			glVertex3f(-100.0,-8.5,-100.0);
			glVertex3f(100.0,-8.5,-100.0);
		glEnd();
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, WATER2);
		glBegin(GL_QUADS);
			glVertex3f(100.0,-8.0,100.0);
			glVertex3f(-100.0,-8.0,100.0);
			glVertex3f(-100.0,-8.0,-100.0);
			glVertex3f(100.0,-8.0,-100.0);
		glEnd();

	glPopMatrix();
	//glDisable(GL_LIGHTING);
	glPushMatrix();
		glTranslatef(-11,0.8,-8);
		
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, bucket);
		paintBucket.DrawObject();
		glTranslatef(0,0,3);
		paintBucket.DrawObject();
		glTranslatef(0,0,3);
		paintBucket.DrawObject();
		glTranslatef(0,0,3);
		paintBucket.DrawObject();
		glTranslatef(0,0,3);
		paintBucket.DrawObject();
		glTranslatef(0,0,-12);
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, RED);
		paintLevel.DrawObject();
		glTranslatef(0,0,3);
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, GREEN);
		paintLevel.DrawObject();
		glTranslatef(0,0,3);
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, BLUE);
		paintLevel.DrawObject();
		glTranslatef(0,0,3);
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, WHITE);
		paintLevel.DrawObject();
		glTranslatef(0,0,3);
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, BLACK);
		paintLevel.DrawObject();
		glTranslatef(0,0,3);
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, GLASS);
		waterPot.DrawObject();
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, WATER);
		waterBlob.DrawObject();
		glTranslatef(0,0,4);
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, PLATE);
		saveFolder.DrawObject();
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, GOLD);
		coins.DrawObject();
		
	glPopMatrix();
	//glPushMatrix();
		//glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, WHITE);
		//glTranslatef(1,0.2,1);
		//glScalef(0.5,1.0,0.5);
		//modelPlate.DrawObject();
	//glPopMatrix();
	glPushMatrix();
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, BOMB);
		glTranslatef(14.0,0,5.0);
		
		bomb.DrawObject();
	glPopMatrix();
	glPushMatrix();
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, VRED);
		glTranslatef(14.0,0,3.0);
		plunger.DrawObject();
		glPopMatrix();
	
	if (holdingBomb)
	{
		glPushMatrix();
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, BOMB);
			glTranslatef(mX,mY,mZ);
			bomb.DrawObject();
		glPopMatrix();
	}
	
	glPushMatrix();
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, PLATE);
		glTranslatef(PlateStack.x+1.0,0.4,PlateStack.z+1.0);
		glScalef(0.5,1.0,0.5);
		modelPlate.DrawObject();
	glPopMatrix();
	
	if (movingPlate)
	{
	glPushMatrix();
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, PLATE);
		glTranslatef(mX,mY,mZ);
		modelPlate.DrawObject();
	glPopMatrix();
	}
	
	
	glPushMatrix();
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, TRUNK);
		glTranslatef(4,0.2,0);
		heightPole.DrawObject();
	glPopMatrix();
	glPushMatrix();
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, PLATE);
		glTranslatef(4,0.2+mY,0);
		heightBlock.DrawObject();
	glPopMatrix();
	//glDisable(GL_LIGHTING);
}


vector<hotArea> Plates;
void makePlate(float xx,float zz)
{
		hotArea newplate(xx,zz,2,2);
		Plates.push_back(newplate);	
}




int checkMouseOver(float x,float z)
{
	mouseOverSave = FALSE;
	int retval=0;
	if (heightPoleArea.Check(x,z))
	{
		//cout<<"MOUSE ClICKED RED POT\n";
		retval =1;
	}
	if (PlateStack.Check(x,z))
	{
		//cout<<"MOUSE ClICKED RED POT\n";
		retval =1;
	}
	if (SaveFolder.Check(x,z))
	{
		//cout<<"MOUSE ClICKED RED POT\n";
		mouseOverSave = TRUE;
		retval =1;
	}
	plungerArea.Check(x,z);
	bombPile.Check(x,z);
	RedPot.Check(x,z);
	GreenPot.Check(x,z);
	BluePot.Check(x,z);
	WaterPot.Check(x,z);
	WhitePot.Check(x,z);
	BlackPot.Check(x,z);
	BigPlate.Check(x,z);
	return retval;

	//return 0;
}

int checkClick(float x,float z,int button)
{
	int retval=0;
	if (button == 1)
	{
		if (RedPot.Check(x,z))
		{
			//cout<<"MOUSE ClICKED RED POT\n";
			updatePenColor(RGBRED);
			penUP = 0;
			retval =1;
		}
		if (GreenPot.Check(x,z))
		{
			//cout<<"MOUSE CLICKED GREEN POT\n";
			penUP = 0;
			updatePenColor(RGBGRN);
			retval =1;
		}
		if (BluePot.Check(x,z))
		{
			//cout<<"MOUSE CLICKED BLUE POT\n";
			penUP = 0;
			updatePenColor(RGBBLU);
			retval =1;
		}
		if (WhitePot.Check(x,z))
		{
			//cout<<"MOUSE ClICKED RED POT\n";
			updatePenColor(RGBWHT);
			penUP = 0;
			retval =1;
		}
		if (BlackPot.Check(x,z))
		{
			cout<<"MOUSE ClICKED BLACK POT\n";
			updatePenColor(RGBBLK);
			penUP = 0;
			retval =1;
		}
		if (WaterPot.Check(x,z))
		{
			//cout<<"MOUSE CLICKED BLUE POT\n";
			WATER[0] = pen.red;
			WATER[1] = pen.green;
			WATER[2] = pen.blue;
			pen.red = 0.5;
			pen.green = 0.5;
			pen.blue = 0.5;
			penUP = 1;
			retval =1;
		}
		if (plungerArea.Check(x,z))
		{
			Explode();
			penUP = 1;
			retval=1;
		}
	}
	else
	if (button == 2)
	{
		if (heightPoleArea.Check(x,z))
		{
			//cout<<"MOUSE ClICKED RED POT\n";
			changingHeight = TRUE;
			penUP = 1;
			retval =1;
		}
		if (PlateStack.Check(x,z))
		{
			//cout<<"MOUSE ClICKED RED POT\n";
			movingPlate = TRUE;
			penUP = 1;
			retval =1;
			//currentPlate++;
			//currentPlate
		}
		if (bombPile.Check(x,z))
		{
			holdingBomb = TRUE;
			penUP = 1;
			retval = 1;
		}
	}
	return retval;
	
}

void updatePenColor(int rgb)
{
	if (rgb == RGBRED)
	{
		if ((pen.red + 0.05)<=1.0)
			pen.red+=0.05;
		else
			pen.red = 1.0;
		pen.green-=0.05;
		pen.blue-=0.05;
	}
	if (rgb == RGBGRN)
	{
		if ((pen.green + 0.05)<=1.0)
			pen.green+=0.05;
		else
			pen.green = 1.0;
		pen.red-=0.05;
		pen.blue-=0.05;
	}
	if (rgb == RGBBLU)
	{
		if ((pen.blue + 0.05)<=1.0)
			pen.blue+=0.05;
		else
			pen.blue = 1.0;
		pen.green-=0.05;
		pen.red-=0.05;
	}
	if (rgb == RGBWHT)
	{
		if ((pen.blue + 0.05)<=1.0)
			pen.blue+=0.05;
		else
			pen.blue = 1.0;
		if ((pen.green + 0.05)<=1.0)
			pen.green+=0.05;
		else
			pen.green = 1.0;
		if ((pen.red + 0.05)<=1.0)
			pen.red+=0.05;
		else
			pen.red = 1.0;
		
	}
	if (rgb == RGBBLK)
	{
		
			pen.blue-=0.05;
		
			pen.green-=0.05;
		
			pen.red -=0.5;
		
	}
	if (pen.red < 0)
	{
		pen.red = 0;
	}
	if (pen.green < 0)
	{
		pen.green = 0;
	}
	if (pen.blue < 0)
	{
		pen.blue = 0;
	}
	//cout<<"Pen color is "<<pen.red<<","<<pen.green<<","<<pen.blue<<endl;

}


void writeShot(int dOP)
{
	
	time_t rawtime;
 	time(&rawtime);
	string filename;
	string timestring;
	string strnum="";
	stringstream strm;
	strm<<savecount;
	strm>>strnum;
	filename = "./Renders/Tatoudra_Render_";
	filename+= strnum;
	filename+= "_";
	timestring= ctime(&rawtime) ;
	timestring.erase((timestring.size()-6), 6);
	timestring.erase(0,(timestring.size()-8));
	filename+=timestring;
	//filename+= "-DApp_Render_";
	filename+= ".tiff";
	//cout<<ctime(&rawtime)<<endl;
	cout<<filename<<endl;
	char cfilename[filename.size()];
	strm.clear();
	strm<<filename;
	strm>>cfilename;
	if (dOP)
	{
	//cout<<cfilename<<endl;
		drawSaveScene();
		glutDisplayFunc(&drawSaveScene);  
		glutIdleFunc(&drawSaveScene);
		drawSaveScene();
	}
	//glutPostRedisplay();
	ilutGLScreen();	
	drawSaveScene();
	ilSaveImage(cfilename);
	glutDisplayFunc(&DrawGLScene);  
	glutIdleFunc(&DrawGLScene);
	savecount++;
	DrawGLScene();
}

void dropPlate(float xx, float zz)
{
	PlateStack.x = xx;
	PlateStack.z = zz;
}




