#include <iostream>
#include <stdlib.h>
#include <fstream>
#include <string>
#include <sstream>

#include <GL/glut.h>    // Header File For The GLUT Library 
#include <GL/gl.h>	// Header File For The OpenGL32 Library
#include <GL/glu.h>	// Header File For The GLu32 Library

#include "OBJFunctions.h"
#include "Basics.h"
using namespace std;

OBJFile::OBJFile()
{
	//cout <<"===================================================Made a new OBJFILE\n";
	faces = makepointList(0,0,0);
	addtopointList(faces,0,0,0);
	addtopointList(faces,0,0,0);
	normals = makepointList(0,0,0);
	addtopointList(normals,0,0,0);
	addtopointList(normals,0,0,0);
}

OBJFile::~OBJFile()
{
	destroypointList(faces);
}
void OBJFile::LoadInObjectFile(char *objfilename)
{
	cout<<"Opening "<<objfilename<<endl;
	float coordCache[10000][3];
	float normCache[10000][3];
	for (int p=0;p<10000;p++)
	{
		coordCache[p][0]=coordCache[p][1]=coordCache[p][2]=0.0;
		normCache[p][0]=normCache[p][1]=normCache[p][2]=0.0;
	}
	int i;
	FILE *f;
	char line[200];
	f=fopen(objfilename,"r");
	i=0;
	if (fopen(objfilename,"r") == NULL)		//Check file exists
		cout<<"Opening "<<objfilename<<" failed "<<endl;
	else
	{
		while(!feof(f))
		{
				fscanf(f,"%s",line);
				if (strcmp(line,"v") == 0)	
				{
					fscanf(f,"%s",line);
					coordCache[i][0] = atof(line);
					fscanf(f,"%s",line);
					coordCache[i][1] = atof(line);
					fscanf(f,"%s",line);
					coordCache[i][2] = atof(line);
					i++;
				}

		}
		fclose(f);
	}
	cout<<"Loaded in Vertices\n";
	f=fopen(objfilename,"r");
	i=0;
	if (fopen(objfilename,"r") == NULL)		//Check file exists
		printf("ERROR\n");
	else
	{
		while(!feof(f))
		{
				fscanf(f,"%s",line);
				if (strcmp(line,"vn") == 0)	
				{
					fscanf(f,"%s",line);
					normCache[i][0] = atof(line);
					fscanf(f,"%s",line);
					normCache[i][1] = atof(line);
					fscanf(f,"%s",line);
					normCache[i][2] = atof(line);
					i++;
				}

		}
		fclose(f);
	}
	cout<<"Loaded in Normals\n";
	
	//cout<<"Loaded OBJ Vertices\n";
	
	//for (int l=0;l<500;l++)
	//{
	//	cout<<"Vertex "<<l<<" is "<<coordCache[l][0]<<","<<coordCache[l][1]<<","<<coordCache[l][2]<<endl;
	//}
	
	
	//-------------------------------------------------------------
	
	
	string rline;
        //char str[2000];
        fstream file_op(objfilename,ios::in);
        while(file_op >> rline)
        {
		 if (rline == "f")
		 {
		 	for (int i=0;i<3;i++)
			{
		 	file_op >> rline;
		 	int index = 0,index2=0,number;
			index = rline.find("/",0);
			//cout << "READ IN "<<rline <<endl;
			//cout << "/ found at "<<index<<endl;
			string firstnum(rline,0,index);
			//cout <<firstnum<<endl;
			index2 = rline.find("/",index+1);
			//cout << "/ found at "<<index2<<endl;
			string secondnum(rline,index+1,index2-index-1);
			//cout <<secondnum<<endl;
			string thirdnum(rline,index2+1,5);
			//cout <<thirdnum<<endl;
			stringstream strm;
			strm<<firstnum;
			strm>>number;
			//'cout<<"Vertex then Norm"<<number; 
			if (number != 0)
					addtopointList(faces,coordCache[number-1][0],coordCache[number-1][1],coordCache[number-1][2]);
			else
					addtopointList(faces,coordCache[0][0],coordCache[0][1],coordCache[0][2]);
			strm.clear();
			strm<<thirdnum;
			strm>>number;
			//cout<<"/"<<number<<endl;
			if (number != 0)
					addtopointList(normals,normCache[number-1][0],normCache[number-1][1],normCache[number-1][2]);
			else
					addtopointList(normals,normCache[0][0],normCache[0][1],normCache[0][2]);
			
			firstnum.erase(0,firstnum.length());
			secondnum.erase(0,secondnum.length());
			thirdnum.erase(0,thirdnum.length());
			}			
			
		 }
	}
	
        file_op.close();
	cout<<"Configured Faces\n";
//cout<<"Loaded in object"<<endl;
//printpointList(faces);
}
		
void OBJFile::DrawObject(void)
{
	//cout<<"Length of Vertex array "<<lengthLL(faces)<<endl;
	//cout<<"Length of Normal array "<<lengthLL(normals)<<endl;
	//printpointList(faces);
	//cout<<"Drawing OBJECT"<<endl;
	pointListNode* current=NULL;
	pointListNode* currentNORM=NULL;
	//cout<<"Faces points to "<<faces<<endl;
	current = faces;
	currentNORM = normals;
	glPushMatrix();
		glBegin(GL_TRIANGLES);
			while (current != NULL)
			{
				if (currentNORM != NULL)
				{
					glNormal3f(currentNORM->x,currentNORM->y,currentNORM->z);
					currentNORM = currentNORM->next;
				}
				//cout<<"Drawing normal "<<currentNORM->x<<","<<currentNORM->y<<","<<currentNORM->z<<endl;
				glVertex3f(current->x,current->y,current->z);
				current = current->next;
				
			}
		glEnd();
	glPopMatrix();
}

void OBJFile::Wipe()
{

}

