#include <GL/glut.h>    // Header File For The GLUT Library 
#include <GL/gl.h>	// Header File For The OpenGL32 Library
#include <GL/glu.h>	// Header File For The GLu32 Library
#include <unistd.h>     // needed to sleep
#include <iostream>
#include <string>
#define ESCAPE 27

#include "GLFunctions.h"
#include "Input.h"
#include "OBJFunctions.h"
#include "Interface.h"
#include "uObject.h"
#include "Explosions.h"
int window;
int toggledrawInterface = 1;
//extern OBJFile hand;
/* The function called whenever a key is pressed. */
void keyPressed(unsigned char key, int x, int y) 
{
    /* avoid thrashing this call */
	usleep(100);
	
	/* If escape is pressed, kill everything. */
	if (key == ESCAPE) 
	{ 
	/* shut down our window */
	glutDestroyWindow(window); 
	
	/* exit the program...normal termination. */
	exit(0);                   
	}
	if (key == 's') 
	{
		writeShot(0);
	}
}

int main(int argc, char **argv) 
{  
  atexit (wipeSlate);
  atexit (objectCleanUp);
   atexit (explosionCleanUp);
  //atexit (wipeSlate);
  glutInit(&argc, argv);  
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_ALPHA | GLUT_DEPTH);  
  glutInitWindowSize(1024, 768);  
  glutInitWindowPosition(0, 0);  
  initInterface();
  window = glutCreateWindow("DApp"); 
  if (toggledrawInterface)
  {
	glutDisplayFunc(&DrawGLScene);  
	//glutFullScreen();
	
	glutIdleFunc(&DrawGLScene);
  }
  else
  {
  	glutDisplayFunc(&drawSaveScene);  
  //glutFullScreen();
  
  	glutIdleFunc(&drawSaveScene);
  }
  glutReshapeFunc(&ReSizeGLScene);
  glutKeyboardFunc(&keyPressed);
  glutPassiveMotionFunc(&PassiveMotion);
  glutMotionFunc(&ClickedMotion);
  glutMouseFunc(&ButtonClick);
  InitGL(1024, 768);
  
  glutMainLoop();  

  return 1;
}




