#include <GL/glut.h>    // Header File For The GLUT Library 
#include <GL/gl.h>	// Header File For The OpenGL32 Library
#include <GL/glu.h>	// Header File For The GLu32 Library
#include <iostream>
#include <cstdlib>
#include <vector>
#include "uObject.h"
#include "Input.h"
#include "Globals.h"
#include "Interface.h"
#include <cmath>
extern int centreOfID;
using namespace std;
// this is the SetX method that belongs to the class Point3 (::)
// resolved by the scope resolution operator ::

uObject::uObject()
{// default constructor
cout<<"WARNING: Dont use a default constructor for this class!"<<endl;
coords = makepointList(0,0,0);
color[0] = 1.0;
color[1] = 1.0;
color[2] = 1.0;

}

uObject::uObject(float xx, float yy,  float zz,float r, float g, float b)
{
coords = makepointList(xx,yy,zz);
color[0] = r;
color[1] = g;
color[2] = b;

}


void uObject::AddCoords(float xx, float yy, float zz)
{
	addtopointList(coords,xx,yy,zz);
}

void uObject::DrawObject()
{
	pointListNode* current;
	current = coords;
	//cout<<"Before loop"<<endl;
	//printpointList(coords);
	glBegin(GL_LINE_STRIP);
		while (current !=NULL)
		{
			//cout<<"In loop"<<endl;
			glVertex3f(current->x,current->y,current->z);
			//cout<<"Drawn vertex"<<endl;
			current = current->next;
		}

	glEnd();

}

void uObject::Throw(float cXX,float cYY,float cZZ)
{

}

void uObject::Wipe()
{
	destroypointList(coords);
}

uObject::~uObject()
{
	//cout<<"CALLED THE DESTRUCTOR"<<endl;
	//destroypointList(coords);
}
vector<uObject> objectList;
extern mypen pen;
void makeShape(pointListNode* startcoords)
{
	//cout<<"makeShape Called\n";
	if (startcoords != NULL)
	{
		//cout<<"makeShape:Start isnt NULL\n";
		//uObject* mynewobject=NULL;
		pointListNode* current;
		float firstcoords[3];
		float lastcoords[3];
		float differencefirstlast[3];
		float sensitivity = 0.01;
		current = startcoords;
		uObject newobject(current->x,current->y,current->z,pen.red,pen.green,pen.blue);
		firstcoords[0] = current->x;
		firstcoords[1] = current->y;
		firstcoords[2] = current->z;
		
		current = current->next;
		while (current !=NULL)
		{
			
			newobject.AddCoords(current->x,current->y,current->z);
			//cout<<"DEBUG: Called addcoords with "<<current->x<<","<<current->y<<","<<current->z<<endl;
			lastcoords[0] = current->x;
			lastcoords[1] = current->y;
			lastcoords[2] = current->z;
			current = current->next;
		}
		differencefirstlast[0] = lastcoords[0] - firstcoords[0];
		differencefirstlast[1] = lastcoords[1] - firstcoords[1];
		differencefirstlast[2] = lastcoords[2] - firstcoords[2];
		if (abs(differencefirstlast[0]) < sensitivity && abs(differencefirstlast[1]) < sensitivity && abs(differencefirstlast[2]) < sensitivity)
		{
			newobject.AddCoords(firstcoords[0],firstcoords[1],firstcoords[2]);
		}
		//printpointList(newobject.coords);
		
		objectList.push_back(newobject);
		//printpointList(objectList[0].coords);
		//cout<<"DEBUG: Pushed new obj onto objList"<<endl;
	}	
}


void movePoint(int ID,int pX,int pY,int nX,int nY)
{
	pointListNode* current;
	current = objectList[ID].coords;
		while (current != NULL)
		{
			if (current->x == pX && current->y == pY)
			{
				current->x = nX;
				current->y = nY;
				break;
			}
			else
				current = current->next;
		}
		


}

void moveuObject(int ID,float oX,float oY,float oZ)
{
	//cout<<"MOVING OBJECT "<<ID<<" by "<<oX<<","<<oY<<","<<oZ<<endl;
	pointListNode* current;
	current = objectList[ID].coords;
		while (current != NULL)
		{
			
				current->x += oX;
				current->y += oY;
				current->z += oZ;
				current = current->next;
		}
		


}

void moveAll(float ofX,float ofY,float ofZ)
{
	//cout<<"-------------------MOVING ALL BY "<<ofX<<","<<ofY<<","<<ofZ<<endl;
	for (unsigned int i=0;i<objectList.size();i++)
	{
		moveuObject(i,ofX,0.0,ofZ);
	}
}


void drawObjects()
{
	
	for (unsigned int i=0;i<objectList.size();i++)
	{
		//if (centreOfID == (int)i)
		//{	
		//	glColor3f(1.0,0.0,0.0);
		//}
		//else
		//{
			//glLineWidth(80);
			float objColor[4];
			objColor[0] = objectList[i].color[0];
			objColor[1] = objectList[i].color[1];
			objColor[2] = objectList[i].color[2];
			objColor[3] = 0.8;
			glLineWidth(10);
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, objColor);
			objectList[i].DrawObject();
			glLineWidth(1);
			//glColor3f(objectList[i].color[0],objectList[i].color[1],objectList[i].color[2]);
		//}
		//cout<<"List of "<<objectList.size()<<" objects"<<endl;
		
		
	}

}

void objectCleanUp()
{
	for (unsigned int i=0;i<objectList.size();i++)
	{
		objectList[i].Wipe();
		
	}
	cout<<"Cleaned up after myself...mmmm....lemon fresh\n";
}
	






























